//
//  Shader.fsh
//  FatCatBurglar
//
//  Created by Tmi Parabits on 8/20/11.
//  Copyright 2011 SoftCubicle. All rights reserved.
//

uniform vec3  SurfaceColor; // (0.75, 0.75, 0.75)
uniform vec3  WarmColor;    // (0.6, 0.6, 0.0)
uniform vec3  CoolColor;    // (0.0, 0.0, 0.6)
uniform float DiffuseWarm;  // 0.45
uniform float DiffuseCool;  // 0.45

varying float NdotL;
varying vec3  ReflectVec;
varying vec3  ViewVec;

varying vec2 position;

void main (void)
{
 
    float f=15.0*360.0*0.0175;
    float g=60.0;
    
    float mix1=(1.0+sin(position.x*(f+g)))*0.5;
    float mix2=(1.0-cos(position.y*(f+g)))*0.5;
    
    vec3 SurfaceColor=mix(vec3(0.0, 1.0, 0.0), vec3(0.0,0.5,0.0), mix1+mix2);
    vec3 WarmColor=mix(vec3(1.0, 0.0, 0.0), vec3(0.0,0.5,0.0), mix1+mix2);
    vec3 CoolColor=mix(vec3(1.0, 1.0, 0.0), vec3(0.0,0.5,0.0), mix1+mix2);
    
    /*vec3 SurfaceColor=vec3(0.75,0.75,0.75);
    vec3 WarmColor=vec3(0.6,0.6,0.0);
    vec3 CoolColor=vec3(0.0,0.0,0.6);*/
    
    float DiffuseWarm=0.45;
    float DiffuseCool=0.45;
    
    vec3 kcool    = min(CoolColor + DiffuseCool * SurfaceColor, 1.0);
    vec3 kwarm    = min(WarmColor + DiffuseWarm * SurfaceColor, 1.0); 
    vec3 kfinal   = mix(kcool, kwarm, NdotL);
    
    vec3 nreflect = normalize(ReflectVec);
    vec3 nview    = normalize(ViewVec);
    
    float spec    = max(dot(nreflect, nview), 0.0);
    spec          = pow(spec, 40.0);
    
    gl_FragColor = vec4 (min(kfinal + spec, 1.0), 1.0);
    
}
                        
    /*
     
     
     void main()
     {
     gl_FragColor=texture2D(texture, textureCoordsOut);
     }
     varying vec4 colorVarying;
     uniform sampler2D texture;
     varying vec2 textureCoordsOut;
     varying vec3 normal;
     
     void main()
     {
     //float intensity=dot(normal, vec3(10.0,10.0,10.0));
     
     gl_FragColor = mix(vec4(0.0,1.0,0.0,1.0),vec4(normal, 1.0), 0.25);
     }
     */